# Makefile for bison

.c.obj :
     msc $*,$* /AC /DLINT_ARGS=1 /W3 /Zi ; >$*.err
     type $*.err


OBJECTS = LR0.obj allocate.obj closure.obj \
	conflicts.obj derives.obj files.obj	\
	getargs.obj gram.obj lalr.obj \
	lex.obj main.obj nullable.obj output.obj print.obj \
	reader.obj symtab.obj warshall.obj

func.h :
	msc /Zg /AC *.c ; >func.h

files.obj: files.c files.h new.h gram.h

LR0.obj: LR0.c machine.h new.h gram.h state.h

allocate.obj: allocate.c func.h

closure.obj: closure.c machine.h new.h gram.h

conflicts.obj: conflicts.c machine.h new.h files.h gram.h state.h

derives.obj: derives.c new.h types.h gram.h

getargs.obj: getargs.c files.h

gram.obj: gram.c func.h

lalr.obj: lalr.c machine.h types.h state.h new.h gram.h

lex.obj: lex.c files.h symtab.h lex.h

main.obj: main.c machine.h

nullable.obj: nullable.c types.h gram.h new.h

output.obj: output.c machine.h new.h files.h gram.h state.h

print.obj: print.c machine.h new.h files.h gram.h state.h

reader.obj: reader.c files.h new.h symtab.h lex.h gram.h

symtab.obj: symtab.c new.h symtab.h gram.h

warshall.obj: warshall.c machine.h

bison.exe: $(OBJECTS)
	link @files.bis

   
